﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class _RadGridDefault : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        
    }

    protected void RadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = PopulateGrid;
    }

    public DataTable PopulateGrid
    {
        get
        {
            DataTable data;

            if (Session["GridData"] == null)
            {
                data = GenerateData();

                Session["GridData"] = data;
            }

             data = (DataTable)Session["GridData"];

            return data;
        }
        
        set
        {
            Session["GridData"] = value;
        }
    }

    public DataTable GenerateData()
    {
        DataTable data = new DataTable();

        data.Columns.Add("ID", typeof(int));
        data.Columns.Add("Name");
        data.Columns.Add("Description");
        data.Columns.Add("SignatureDate", typeof(DateTime));

        for (int i = 1; i < 31; i++)
        {
            data.Rows.Add(i, "Name" + (i % 5).ToString(), "Description" + i.ToString(), DateTime.Now.AddDays(i));
        }

        return data;
    }

    protected void RadGrid1_UpdateCommand(object sender, GridCommandEventArgs e)
    {
        var editItem = e.Item as GridEditFormItem;

        DataTable newData = PopulateGrid;

        DataRow[] row = newData.Select("ID = " + (editItem["ID"].Controls[0] as TextBox).Text);

        row[0]["ID"] = (editItem["ID"].Controls[0] as TextBox).Text;
        row[0]["Name"] = (editItem["Name"].Controls[0] as TextBox).Text;
        row[0]["Description"] = (editItem["Description"].Controls[0] as TextBox).Text;
        row[0]["SignatureDate"] = (editItem["SignatureDate"].Controls[0] as RadDatePicker).SelectedDate;

        newData.AcceptChanges();

    }

}